#define MAX_MTARGETS		32
#define MTARGET_MIN_SPEED	2
#define MTARGET_MAX_SPEED	11
#define MTARGET_RADIUS	4
#define MTARGET_COLOUR	0x0000ff00
int mtargets[32][3];		//x and y coord and speed for each target
int num_mtargets;

void add_mtarget (int x, int y, int speed) {
	mtargets[num_mtargets][0] = x;
	mtargets[num_mtargets][1] = y;
	mtargets[num_mtargets][2] = speed;
	num_mtargets++;
}

void remove_mtarget (int target) {
	int i;
	num_mtargets -= 1;

	//For removing the last target, we are done.
	if (target == num_mtargets) {
		return;
	}

	//For removing a target in the middle, shift the rest down.
	for (i = target; i < num_mtargets; i++) {
		mtargets[i][0] = mtargets[i + 1][0];
		mtargets[i][1] = mtargets[i + 1][1];
		mtargets[i][2] = mtargets[i + 1][2];
	}
}

void draw_mtargets () {
	int i;

	for (i = 0; i < num_mtargets; i++) {
		rect(mtargets[i][0] - MTARGET_RADIUS + 1,
			mtargets[i][1] - MTARGET_RADIUS + 1,
			mtargets[i][0] + MTARGET_RADIUS - 1,
			mtargets[i][1] + MTARGET_RADIUS - 1,
			MTARGET_COLOUR);
	}
}


void MatrixProcFrame(int quadFoundRedFlag) {
	int random_x, random_speed;
	int i;

	//Making new targets
	if (num_mtargets < MAX_MTARGETS) {
		if (rand() % 10 == 0) {			//Spawn a new target?
			random_x = rand() % WIDTH;	//Random x coordinate
			random_speed = rand() % (MTARGET_MAX_SPEED - MTARGET_MIN_SPEED + 1) + MTARGET_MIN_SPEED;
			add_mtarget(random_x, 0, random_speed);		//Add new target
		}
	}

	//Move targets and detect explosion
	for (i = num_mtargets - 1; i >= 0; i--) {
		mtargets[i][1] += mtargets[i][2];

		if (mtargets[i][1] >= HEIGHT) {
			remove_mtarget(i);
		}
	}

	draw_mtargets();
}
