
module svga_control (
clock,
user_vga_addr,
user_vga_read,
user_vga_write,
user_vga_write_byte_a,
user_vga_write_byte_b,
user_vga_write_byte_c,
user_vga_write_byte_d,
user_vga_enable,
user_vga_read_data,
user_vga_write_data,
user_access_ok,
user_clock,
user_ram_clock,
user_clock_enable,
user_load_vga_addr
);
 
input clock;
output [18:0]	user_vga_addr;
output 		user_vga_read;
output 		user_vga_write;
output 		user_vga_write_byte_a;
output 		user_vga_write_byte_b;
output 		user_vga_write_byte_c;
output 		user_vga_write_byte_d;
output 		user_vga_enable;
input [31:0]	user_vga_read_data;
output  [31:0]	user_vga_write_data;
input		user_access_ok;
output			user_clock				/* synthesis syn_noclockbuf = 1 */; // user clock output
output			user_ram_clock			/* synthesis syn_noclockbuf = 1 */; // user clock for the RAM output
output			user_clock_enable;
output			user_load_vga_addr;			// flag to load the address specified by the user_vga_addr bus 

//add a counter to cycle between colours
reg	[3:0]	counter;
reg [18:0]	user_vga_addr;

always @ (posedge user_access_ok)
begin
	counter <= counter + 1;
end


always @ (posedge clock)
begin
	if (user_access_ok)
		user_vga_addr <= user_vga_addr + 1;
	else
		user_vga_addr <= 19'h00000;
end


//working with one address and one colour
//assign user_vga_write_data = 32'h00FFFF00;
//assign user_vga_addr = 19'h0ffff;
//assign user_vga_addr = 19'h0;

//try rotating colors (per user_access_ok)
assign user_vga_write_data[31:24] = counter[3] ? 8'hFF : 8'h00;
assign user_vga_write_data[23:16] = counter[2] ? 8'hFF : 8'h00;
assign user_vga_write_data[15:8]  = counter[1] ? 8'hFF : 8'h00;
assign user_vga_write_data[7:0]   = counter[0] ? 8'hFF : 8'h00;

assign user_clock = clock;
assign user_ram_clock = clock;
assign user_vga_enable = 1'b1;
assign user_clock_enable = 1'b1;
assign user_load_vga_addr = 1'b1;

assign user_vga_read = 1'b0;
assign user_vga_write = 1'b1;
assign user_vga_write_byte_a = 1'b1;
assign user_vga_write_byte_b = 1'b1;
assign user_vga_write_byte_c = 1'b1;
assign user_vga_write_byte_d = 1'b1;


endmodule // svga_control




