/*
 *  * Copyright (c) 2004 Xilinx, Inc.  All rights reserved.
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 6.3 EDK_Gmm.11.2
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    W:\ece532\zbt_as_data
 */


// Located in: microblaze_0/include/xparameters.h
#include "xparameters.h"
#include "xutil.h"
#include "xbasic_types.h"
#include "xgpio.h"

#define WIDTH	640
#define HEIGHT	480

#include "CheckRedFlag.h"

typedef unsigned char uchar;


//macros for screen writing
long makecol (uchar r, uchar g, uchar b) {
	return ( (b) | ((g) << 8) | ((r) << 16) );
}

#define putpixel(x, y, col)	\
	screen[y * WIDTH + x] = col;


void clear_screen (long col) {
	register long *screen = (long*)XPAR_ZBT_512KX32_MEM0_BASEADDR;
	register const long *screen_end = (long*)(screen + HEIGHT*WIDTH);

	while (screen < screen_end)
		*(screen++) = col;
}

void rect (int x1, int y1, int x2, int y2, long col) {
	register const long *screen = (long*)XPAR_ZBT_512KX32_MEM0_BASEADDR;
	register long *pixel, *pixel_end;
	int y;

	for (y = y1; y < y2; y++)
	{
		pixel = (long*)(screen + y*WIDTH + x1);
		pixel_end = (long*)(pixel + x2 - x1);
		
		while (pixel < pixel_end)
			*(pixel++) = col;
	}
}

//====================================================

	/* 
	* MemoryTest routine will not be run for the memory at 
	* dlmb_cntlr.C_BASEADDR
	* because it is being used to hold a part of this application program
	*/
	
	/* 
	* MemoryTest routine will not be run for the memory at 
	* ilmb_cntlr.C_BASEADDR
	* because it is being used to hold a part of this application program
	*/
	
	/* 
	* MemoryTest routine will not be run for the memory at 
	* ZBT_512Kx32.C_MEM0_BASEADDR
	* because it is being used to hold a part of this application program
	*/
	

#define WIDTH_GREEN	(10)
#define MAX_X_GREEN	(630)	//= 640-10

#define ZBTSWITCH_DIRMASK	(1)		//currently only using lowest bit


int main (void)
{
	//setup variables
	uchar rot_redcolor = 0;
	int buffer_count = 0;
	int buffer_count_read = 0;
	int x_green = 0;
	int delay;
	int quadFoundRedFlag;
	XStatus status;
	XGpio gpio_ZBTswitch;
	
	//setup hit-detection rectangles
	SetupQuadrants();
	
	//setup ZBT_Switch GPIO
	status = XGpio_Initialize(&gpio_ZBTswitch, XPAR_ZBT_SWITCH_CONTROL_DEVICE_ID);
	if (status != XST_SUCCESS)
		return 0;
	//output on (a 0 bit = output)
	XGpio_SetDataDirection(&gpio_ZBTswitch, 1, ~ZBTSWITCH_DIRMASK);
	//input on  (a 1 bit = input)
	XGpio_SetDataDirection(&gpio_ZBTswitch, 2, ZBTSWITCH_DIRMASK);
	
	while(1)
	{
		//DELAY
		//for (delay=0; delay<1000000; delay++)
		//	;

		//swap buffers now that we are done drawing
		buffer_count = (buffer_count == 1) ? 0 : 1;
		XGpio_DiscreteWrite(&gpio_ZBTswitch, 1, buffer_count);

		//WAIT FOR SYNC WITH BLANKING PERIOD before drawing next frame
		while (buffer_count_read != buffer_count)
		{
			buffer_count_read = XGpio_DiscreteRead(&gpio_ZBTswitch, 2) & 1;
		}
		
		
		//BELOW LINE IS SLOW!
		// DON'T need now:  let video input provide initial frame data
		//clear_screen(makecol(255, 255, 255)); //black
		
		//#define BOX_SIZE  (20)
		//rect(WIDTH/2-BOX_SIZE, HEIGHT/2-BOX_SIZE, WIDTH/2+BOX_SIZE, HEIGHT/2+BOX_SIZE,
		//	makecol(++rot_redcolor, 0, 0)); //red
		
/*		rect(50, 50, 250, 550, makecol(255, 192, 32)); //orange
		rect(600, 20, 760, 100, makecol(255, 255, 0)); //yellow
		rect(600, 200, 640, 480, makecol(255, 64, 255)); //mauve
*/		
		quadFoundRedFlag = LocateFlagSector();
		if (quadFoundRedFlag != 0)
		{
	#define BOX_WIDTH 5
			//draw box marking quadrant found
			rect(CHECK_QUAD_RECTS[quadFoundRedFlag-1][LEFT],  CHECK_QUAD_RECTS[quadFoundRedFlag-1][TOP],
				 CHECK_QUAD_RECTS[quadFoundRedFlag-1][RIGHT], CHECK_QUAD_RECTS[quadFoundRedFlag-1][TOP]+BOX_WIDTH,
				 makecol(0,0,255));
			rect(CHECK_QUAD_RECTS[quadFoundRedFlag-1][LEFT],  CHECK_QUAD_RECTS[quadFoundRedFlag-1][TOP],
				 CHECK_QUAD_RECTS[quadFoundRedFlag-1][LEFT]+BOX_WIDTH, CHECK_QUAD_RECTS[quadFoundRedFlag-1][BOTTOM],
				 makecol(0,0,255));
			rect(CHECK_QUAD_RECTS[quadFoundRedFlag-1][LEFT],  CHECK_QUAD_RECTS[quadFoundRedFlag-1][BOTTOM]-BOX_WIDTH,
				 CHECK_QUAD_RECTS[quadFoundRedFlag-1][RIGHT], CHECK_QUAD_RECTS[quadFoundRedFlag-1][BOTTOM],
				 makecol(0,0,255));
			rect(CHECK_QUAD_RECTS[quadFoundRedFlag-1][RIGHT]-BOX_WIDTH,  CHECK_QUAD_RECTS[quadFoundRedFlag-1][TOP],
				 CHECK_QUAD_RECTS[quadFoundRedFlag-1][RIGHT], CHECK_QUAD_RECTS[quadFoundRedFlag-1][BOTTOM],
				 makecol(0,0,255));
		}
		
		//try making this move across the screen horizontally!
		//rect(x_green-1, 470, x_green, 480, makecol(0,0,0));
		rect(x_green, 470, x_green+WIDTH_GREEN, 480, makecol(50, 255, 50)); //green
		if (++x_green == MAX_X_GREEN)
			x_green = 0;
		
	}
	
	return 0;
}

