

module data_gen_for_fsl_sh_mem_controller
  (	
  core_clk,
  mem_clk,
  clk_27mhz,
  clk_25mhz,
  clk_50mhz,
  reset,
  led0,
  led1,

  VIDEO_INPUT,

  VGA_OUT_PIXEL_CLOCK_P,
  VGA_COMP_SYNCH_N,
  VGA_OUT_BLANK_N,
  VGA_HSYNCH_N,
  VGA_VSYNCH_N,
  VGA_OUT_RED_P,
  VGA_OUT_GREEN_P,
  VGA_OUT_BLUE_P,

  Dq_0, 
  Addr_0, 
  mem_clk_0,
  CKEb_0, 
  Bwa_n_0, 
  Bwb_n_0, 
  Bwc_n_0, 
  Bwd_n_0,
  WEb_0, 
  ADV_0, 
  OEb_0,                  
  CS1b_0, 
  //CS2_0, 
  //CS2b_0, 
  LBOb_0, 
  ZZ_0,

  Dq_1, 
  Addr_1, 
  mem_clk_1,
  CKEb_1, 
  Bwa_n_1, 
  Bwb_n_1, 
  Bwc_n_1, 
  Bwd_n_1,
  WEb_1, 
  ADV_1, 
  OEb_1,                  
  CS1b_1, 
  //CS2_1, 
  //CS2b_1, 
  LBOb_1, 
  ZZ_1

  
  /*Dq_2, 
  Addr_2, 
  mem_clk_2,
  CKEb_2, 
  Bwa_n_2, 
  Bwb_n_2, 
  Bwc_n_2, 
  Bwd_n_2,
  WEb_2, 
  ADV_2, 
  OEb_2,                  
  CS1b_2, 
  //CS2_2, 
  //CS2b_2, 
  LBOb_2, 
  ZZ_2*/
  
        );

input core_clk, mem_clk, reset;
input clk_27mhz;
input clk_25mhz;
input clk_50mhz;
output led0, led1;

input[7:0] VIDEO_INPUT;

output VGA_OUT_PIXEL_CLOCK_P;
output VGA_COMP_SYNCH_N;
output VGA_OUT_BLANK_N;
output VGA_HSYNCH_N;
output VGA_VSYNCH_N;
output [7:0] VGA_OUT_RED_P;
output [7:0] VGA_OUT_GREEN_P;
output [7:0] VGA_OUT_BLUE_P;

inout Dq_0, Dq_1;
output Addr_0, Addr_1;
output mem_clk_0, mem_clk_1;
output CKEb_0, CKEb_1;
output Bwa_n_0, Bwa_n_1;
output Bwb_n_0, Bwb_n_1;
output Bwc_n_0, Bwc_n_1;
output Bwd_n_0, Bwd_n_1;
output WEb_0, WEb_1;
output ADV_0, ADV_1;
output OEb_0, OEb_1;
output CS1b_0, CS1b_1;
//output CS2_0, CS2_1;
//output CS2b_0, CS2b_1;
output LBOb_0, LBOb_1;
output ZZ_0, ZZ_1;

/*
inout Dq_2;
output Addr_2;
output mem_clk_2;
output CKEb_2;
output Bwa_n_2;
output Bwb_n_2;
output Bwc_n_2;
output Bwd_n_2;
output WEb_2;
output ADV_2;
output OEb_2;
output CS1b_2;
//output CS2_2;
//output CS2b_2;
output LBOb_2;
output ZZ_2;
*/

wire core_clk, mem_clk; 
wire clk_27mhz;
wire clk_25mhz;
wire clk_50mhz;
wire in_clk;     //clk from testbench to system
wire reset;
wire fsl_rst;
wire rst;  //used to startup the system in a predictable mode

//wire int_rst; //FOR DEBUGGING: used with bufg
reg [1:0] reset_state, next_reset_state;
reg vid_out_rst, sh_mem_rst, vid_in_rst;

parameter total_rst=0;
parameter vid_out_done_rst=1;
parameter shared_mem_done_rst=2;
parameter vid_in_done_rst=3;

//reg led0, led1;
wire led0, led1;
wire led0_unused, led1_unused;
wire led0_unused_b, led1_unused_b;
wire led0_unused_c, led1_unused_c;

wire[7:0] VIDEO_INPUT;

wire VGA_OUT_PIXEL_CLOCK_P;
wire VGA_COMP_SYNCH_N;
wire VGA_OUT_BLANK_N;
wire VGA_HSYNCH_N;
wire VGA_VSYNCH_N;
wire [7:0] VGA_OUT_RED_P;
wire [7:0] VGA_OUT_GREEN_P;
wire [7:0] VGA_OUT_BLUE_P;

wire [31:0] Dq_0, Dq_1; //Data I/O- 
			//NOTE: the only input/output signal in the module
wire [18:0] Addr_0, Addr_1; //Address
wire mem_clk_0, mem_clk_1;
wire ADV_0, ADV_1;     //Address advance
wire CKEb_0, CKEb_1;    //Slow down mode: acts as a clock enable
wire WEb_0, WEb_1;     //Read is high and Write is Low aka "read, not write"
wire Bwa_n_0, Bwa_n_1;	//Byte Write Enable A
wire Bwb_n_0, Bwb_n_1;	//Byte Write Enable B
wire Bwc_n_0, Bwc_n_1;	//Byte Write Enable C
wire Bwd_n_0, Bwd_n_1;	//Byte Write Enable D
wire CS1b_0, CS1b_1;	//Chip Enable
wire CS2_0, CS2_1;	//Chip Enable
wire CS2b_0, CS2b_1;	//Chip Enable
wire OEb_0, OEb_1;	//Chip Output Enable
wire ZZ_0, ZZ_1;	//Chip Enable vs Sleep Mode
wire LBOb_0, LBOb_1;	//Used to select the autom byte advance mode (ADV) where
			//LBOb = Linear Burst Order bar

/**USED FOR DEBUGGING*
wire [31:0] Dq_2; //Data I/O- 
			//NOTE: the only input/output signal in the module
wire [18:0] Addr_2; //Address
wire mem_clk_2;
wire ADV_2;     //Address advance
wire CKEb_2;    //Slow down mode: acts as a clock enable
wire WEb_2;     //Read is high and Write is Low aka "read, not write"
wire Bwa_n_2;	//Byte Write Enable A
wire Bwb_n_2;	//Byte Write Enable B
wire Bwc_n_2;	//Byte Write Enable C
wire Bwd_n_2;	//Byte Write Enable D
wire CS1b_2;	//Chip Enable
wire CS2_2;	//Chip Enable
wire CS2b_2;	//Chip Enable
wire OEb_2;	//Chip Output Enable
wire ZZ_2;	//Chip Enable vs Sleep Mode
wire LBOb_2;	//Used to select the autom byte advance mode (ADV) where
			//LBOb = Linear Burst Order bar
*/
			
wire no_sig; //unused signal

//FSL0 signals writes from video input to memory A:
wire fsl_0_rst;
wire fsl_0_full, fsl_0_has_data;
wire fsl_m_vid_in_clk, fsl_m_vid_in_full;
wire fsl_m_vid_in_write, fsl_m_vid_in_cntrl;
wire[0:31] fsl_m_vid_in_data;
wire fsl_s_memA_clk, fsl_s_memA_read; 
wire fsl_s_memA_cntrl, fsl_s_memA_exists;
wire [0:31] fsl_s_memA_data;

//FSL2 signals writes from video output to memory B:
wire fsl_2_rst;
wire fsl_2_full, fsl_2_has_data;
wire fsl_m_vid_out_clk, fsl_m_vid_out_full;
wire fsl_m_vid_out_write, fsl_m_vid_out_cntrl;
wire[0:31] fsl_m_vid_out_data;
wire fsl_s_memB_clk, fsl_s_memB_read; 
wire fsl_s_memB_cntrl, fsl_s_memB_exists;
wire [0:31] fsl_s_memB_data;

//FSL3 signals writes from memory B to video out (mem C for now):
wire fsl_3_rst;
wire fsl_3_full, fsl_3_has_data;
wire fsl_m_memB_clk, fsl_m_memB_full;
wire fsl_m_memB_write, fsl_m_memB_cntrl;
wire[0:31] fsl_m_memB_data;
wire fsl_s_vid_out_clk, fsl_s_vid_out_read; 
wire fsl_s_vid_out_cntrl, fsl_s_vid_out_exists;
wire [0:31] fsl_s_vid_out_data;

//wire unused_clk, unused_rst, unused_read;
//wire unused_mclk, unused_write, unused_cntrl, FSL_M_Full_C;
//wire [0:31] unused_data;
//wire vfifo_empty, vfifo_full, vread_not_write, venable;
//wire [0:18] vmem_addr;
//wire [0:12] vaddr_msb_req;
//wire [0:31] vmem_in_data, vmem_out_data;
//wire vread_fifo, vwrite_fifo, vrunning, vdone, vreq_mem_arb;
//reg vcontrol_mem;
//reg vprev_done;

wire unused_ok, unused_select;
wire empty_signal, frame_batch; //SHOULD BE EASILY REMOVED

wire vunused_clk, vunused_read;
  

//OUTPUTS FROM SH_MEM CONTROLLER THAT ARE CURRENTLY UNUSED:
//wire FSL_M_Clk_B, FSL_M_Write_B, FSL_M_Control_B; 
//reg FSL_M_Full_B;
//wire FSL_M_Full_B;
//wire [31:0] FSL_M_Data_B;
wire FSL_M_Clk_A, FSL_M_Write_A, FSL_M_Control_A; 
//reg FSL_M_Full_A;
wire FSL_M_Full_A;
wire [31:0] FSL_M_Data_A;

/*
reg [1:0] addr_msb;
reg [2:0] state_cntr;
reg [31:0] data_cntr;
reg [7:0] delay_cntr;
reg [0:2] pres_state, next_state;
*/
/*
//parameter st_reset=0;
parameter st_write_data_instr=0;
parameter st_write_data_addr=1;
parameter st_start_write_data=2;
parameter st_write_data=3;
//parameter st_rx_data_instr=3;
//parameter st_rx_data_addr=4;
//parameter st_rx_data=5;
//parameter st_read_req_data_instr=6;
//parameter st_read_req_data_addr=7;
parameter st_delay=4;
*/
/*
`define wr_dat_instr 32'h00001007
`define wr_dat_0_addr 30'h00000000
`define wr_dat_20_addr 30'h00000020
`define wr_dat_40_addr 30'h00000040
`define wr_dat_60_addr 30'h00000060
`define wr_dat_10_addr 30'h00000010
`define wr_dat_30_addr 30'h00000030
`define wr_dat_50_addr 30'h00000050
`define wr_dat_70_addr 30'h00000070
`define noop 32'h00000004
*/
/*
//Memory model for actual zbt bank (0)
//**NOTE THESE WILL BE ACTUAL SYSTEM INPUTS AND OUTPUTS ON THE BOARD:
   K7N163601A K7N163601A_bank0  (
  .Dq(Dq_0), 
  .Addr(Addr_0), 
  .K(in_clk), 
  .CKEb(CKEb_0), 
  .Bwa_n(Bwa_n_0), 
  .Bwb_n(Bwb_n_0), 
  .Bwc_n(Bwc_n_0), 
  .Bwd_n(Bwd_n_0),
  .WEb(WEb_0), 
  .ADV(ADV_0), 
  .OEb(OEb_0),                  
  .CS1b(CS1b_0), 
  .CS2(CS2_0), 
  .CS2b(CS2b_0), 
  .LBOb(LBOb_0), 
  .ZZ(ZZ_0)
  );

   K7N163601A K7N163601A_bank1 (
  .Dq(Dq_1), 
  .Addr(Addr_1), 
  .K(in_clk), 
  .CKEb(CKEb_1), 
  .Bwa_n(Bwa_n_1), 
  .Bwb_n(Bwb_n_1), 
  .Bwc_n(Bwc_n_1), 
  .Bwd_n(Bwd_n_1),
  .WEb(WEb_1), 
  .ADV(ADV_1), 
  .OEb(OEb_1),                  
  .CS1b(CS1b_1), 
  .CS2(CS2_1), 
  .CS2b(CS2b_1), 
  .LBOb(LBOb_1), 
  .ZZ(ZZ_1)
  );
*/


fsl_video_input fsl_video_input (
    .clk(clk_27mhz), 
    .rst(vid_in_rst), 
    .VIDEO_INPUT(VIDEO_INPUT), 
   
    .FSL_M_Full(fsl_m_vid_in_full), 
    .FSL_M_Clk(fsl_m_vid_in_clk), 
    .FSL_M_Data(fsl_m_vid_in_data), 
    .FSL_M_Control(fsl_m_vid_in_cntrl), 
    .FSL_M_Write(fsl_m_vid_in_write),

    //Added for use with "new" files:
    .FSL_S_Clk(vunused_clk),
    .FSL_S_Read(vunused_read),
    .FSL_S_Data(32'b0),  //No input, so it's grounded.
    .FSL_S_Control(1'b0),
    .FSL_S_Exists(1'b0),

    ////Added for program:
    //.prog_instr(32'b0),
    //.prog_instr_read(unused_rd_output),
    //.done_frame(unused_stat_bit0),

    .release_priority(empty_signal),
    .batch(frame_batch),
    //.led0_o(led0_unused),
    //.led1_o(led1_unused)
    .led0_o(led0_unused),
    .led1_o(led1_unused)

    );

  fsl_sh_mem_controller fsl_sh_mem_controller (
  .core_clk(core_clk),
  .mem_clk(mem_clk),
  .rst(sh_mem_rst),

  .led0(led0_unused_b),
  .led1(led1_unused_b),

  .Dq_0(Dq_0), 
  .Addr_0(Addr_0), 
  .mem_clk_0(mem_clk_0),
  .CKEb_0(CKEb_0), 
  .Bwa_n_0(Bwa_n_0), 
  .Bwb_n_0(Bwb_n_0), 
  .Bwc_n_0(Bwc_n_0), 
  .Bwd_n_0(Bwd_n_0),
  .WEb_0(WEb_0), 
  .ADV_0(ADV_0), 
  .OEb_0(OEb_0),                  
  .CS1b_0(CS1b_0), 
  //.CS2_0(CS2_0), 
  //.CS2b_0(CS2b_0), 
  .LBOb_0(LBOb_0), 
  .ZZ_0(ZZ_0),

  .Dq_1(Dq_1), 
  .Addr_1(Addr_1), 
  .mem_clk_1(mem_clk_1),
  .CKEb_1(CKEb_1), 
  .Bwa_n_1(Bwa_n_1), 
  .Bwb_n_1(Bwb_n_1), 
  .Bwc_n_1(Bwc_n_1), 
  .Bwd_n_1(Bwd_n_1),
  .WEb_1(WEb_1), 
  .ADV_1(ADV_1), 
  .OEb_1(OEb_1),                  
  .CS1b_1(CS1b_1), 
  //.CS2_1(CS2_1), 
  //.CS2b_1(CS2b_1), 
  .LBOb_1(LBOb_1), 
  .ZZ_1(ZZ_1),

  .FSL_S_Clk_A(fsl_s_memA_clk),
  .FSL_S_Read_A(fsl_s_memA_read),
  .FSL_S_Data_A(fsl_s_memA_data),
  .FSL_S_Control_A(fsl_s_memA_cntrl),
  .FSL_S_Exists_A(fsl_s_memA_exists),
  .FSL_M_Clk_A(FSL_M_Clk_A),
  .FSL_M_Write_A(FSL_M_Write_A),
  .FSL_M_Data_A(FSL_M_Data_A),
  .FSL_M_Control_A(FSL_M_Control_A),
  .FSL_M_Full_A(FSL_M_Full_A),

  .FSL_S_Clk_B(fsl_s_memB_clk),
  .FSL_S_Read_B(fsl_s_memB_read),
  .FSL_S_Data_B(fsl_s_memB_data),
  .FSL_S_Control_B(fsl_s_memB_cntrl),
  .FSL_S_Exists_B(fsl_s_memB_exists),
  .FSL_M_Clk_B(fsl_m_memB_clk),
  .FSL_M_Write_B(fsl_m_memB_write),
  .FSL_M_Data_B(fsl_m_memB_data),
  .FSL_M_Control_B(fsl_m_memB_cntrl),
  .FSL_M_Full_B(fsl_m_memB_full)

);

fsl_video_output fsl_video_output (
// connections to the DAC
  .VGA_OUT_PIXEL_CLOCK_P(VGA_OUT_PIXEL_CLOCK_P),
  .VGA_COMP_SYNCH_N(VGA_COMP_SYNCH_N),
  .VGA_OUT_BLANK_N(VGA_OUT_BLANK_N),
  .VGA_HSYNCH_N(VGA_HSYNCH_N),
  .VGA_VSYNCH_N(VGA_VSYNCH_N),
  .VGA_OUT_RED_P(VGA_OUT_RED_P),
  .VGA_OUT_GREEN_P(VGA_OUT_GREEN_P),
  .VGA_OUT_BLUE_P(VGA_OUT_BLUE_P),

  .user_access_ok(unused_ok), //unecessary
  .select_user_clock(unused_select), //unecessary
  .pixel_clock(clk_25mhz),
  //.pixel_clock_2x(clk_50mhz), // For FSLs
  .pixel_clock_2x(core_clk), // For FSLs
  .reset(vid_out_rst),

  .led0(led0),
  .led1(led1),

  // Slave FSL Signals
  .FSL_S_Clk(fsl_s_vid_out_clk), //y
  .FSL_S_Read(fsl_s_vid_out_read), //y
  .FSL_S_Data(fsl_s_vid_out_data), //y
  .FSL_S_Control(fsl_s_vid_out_cntrl),
  .FSL_S_Exists(fsl_s_vid_out_exists), //y

  // Master FSL Signals
  .FSL_M_Clk(fsl_m_vid_out_clk),
  .FSL_M_Write(fsl_m_vid_out_write),
  .FSL_M_Data(fsl_m_vid_out_data),
  .FSL_M_Control(fsl_m_vid_out_cntrl),
  .FSL_M_Full(fsl_m_vid_out_full)

);



//****BEGINNING OF MEMORY BANK USED TO MIMIC THE VIDEO OUT RECEIVING INFO****//
/*
fsl_mem_controller fslmem_bank_cntlr_for_vid_out (
//Input Connections for controller:
  .clk(core_clk),
  .rst(rst),
//Connections to Memory Controller:
  //Outputs:
//  mem_clk, //y
 // mem_rst, //y
  .mem_addr(vmem_addr), //y
  .mem_in_data(vmem_in_data), //y
  .fifo_empty(vfifo_empty), //y
  .fifo_full(vfifo_full), //y
  .read_not_write(vread_not_write), //y
  .enable(venable), //y
  //Inputs:
  .read_fifo(vread_fifo), //y
  .write_fifo(vwrite_fifo), //y
  .mem_out_data(vmem_out_data), //y
  .running(vrunning), //y
  .done(vdone), //y

//Connected to arbiter:
  .addr_msb_req(vaddr_msb_req),  //Used to req the correct memory bank
  .req_mem_arb(vreq_mem_arb),  //status request bit to arbiter
  .control_mem0(vcontrol_mem),  //status bit from arbiter
  .control_mem1(vcontrol_mem),  //status bit from arbiter
  .addr_msb_ctrl(vaddr_msb_req),

//Connections to the FSL Memory Controller Program:
  .prog_clk(unused_clk), //y
  .prog_rst(unused_rst), //y
  .prog_instr(32'h00000000),
  .program_cbit(1'b0),
  .prog_instr_read(unused_read),
  .valid_instr(1'b0),

  // Slave FSL Signals
  .FSL_S_Clk(fsl_s_vid_out_clk), //y
  .FSL_S_Read(fsl_s_vid_out_read), //y
  .FSL_S_Data(fsl_s_vid_out_data), //y
  .FSL_S_Control(fsl_s_vid_out_cntrl),
  .FSL_S_Exists(fsl_s_vid_out_exists), //y

  // Master FSL Signals
  .FSL_M_Clk(unused_mclk), //y
  .FSL_M_Write(unused_write), //y
  .FSL_M_Data(unused_data), //y
  .FSL_M_Control(unused_cntrl),
  .FSL_M_Full(FSL_M_Full_C) //y
);

mem_bank_controller mem_bank_cntlr_for_vid_out (	
 
  //Inputs from fsl_controller to memory controller:
  .reset(rst),
  .core_clk(core_clk),
  .in_mem_clk(mem_clk),

  //in_clk, //y
  //rst, //y
  .in_addr(vmem_addr), //y
  .in_data(vmem_in_data), //y
  .fifo_empty(vfifo_empty), //y
  .fifo_full(vfifo_full), //y
  .read_not_write(vread_not_write), 
  .enable(venable), 

  //Outputs from memory controller to fsl_controller:
  .read_fifo(vread_fifo), 
  .write_fifo(vwrite_fifo), 
  .out_data(vmem_out_data), //connected to fsl //y
  .running(vrunning), 
  .done(vdone),

  //****THESE NAMES MAY HAVE TO CHANGE TO MATCH UCF FILE****
  .Dq(Dq_2),  //Data input/output from memory bank  //y

  //Control outputs to memory bank
  .Addr(Addr_2), //y
  .mem_clk(mem_clk_2), //y
  .CKEb(CKEb_2), //y
  .Bwa_n(Bwa_n_2), //y
  .Bwb_n(Bwb_n_2), //y
  .Bwc_n(Bwc_n_2), //y
  .Bwd_n(Bwd_n_2), //y
  .WEb(WEb_2), //y
  .ADV(ADV_2), //y
  .OEb(OEb_2), //y
  .CS1b(CS1b_2), //y
  //CS2(CS2_2), //y
  //CS2b(CS2b_2), //y
  .LBOb(LBOb_2), //y
  .ZZ(ZZ_2) //y

  ); 
*/
//*****END OF MEMORY BANK USED TO MIMIC THE VIDEO OUT RECEIVING INFO*******//

//Note: currently connected to a state machine for input
fsl_v20_532 #(.C_FSL_DEPTH(16)) vid_in_to_memA_fsl0 (  
    .FSL_Clk(no_sig), 
    .SYS_Rst(reset), 
    .FSL_Rst(fsl_0_rst), 
    .FSL_M_Clk(fsl_m_vid_in_clk), 
    .FSL_M_Data(fsl_m_vid_in_data), 
    .FSL_M_Control(fsl_m_vid_in_cntrl), 
    .FSL_M_Write(fsl_m_vid_in_write), 
    .FSL_M_Full(fsl_m_vid_in_full), 
    .FSL_S_Clk(fsl_s_memA_clk), 
    .FSL_S_Data(fsl_s_memA_data), 
    .FSL_S_Control(fsl_s_memA_cntrl), 
    .FSL_S_Read(fsl_s_memA_read), 
    .FSL_S_Exists(fsl_s_memA_exists), 
    .FSL_Full(fsl_0_full), 
    .FSL_Has_Data(fsl_0_has_data)
    );


//Note: currently connected to a state machine for input 
fsl_v20_532 #(.C_FSL_DEPTH(16)) vid_out_to_memB_fsl2 (  
    .FSL_Clk(no_sig), 
    .SYS_Rst(reset), 
    .FSL_Rst(fsl_2_rst), 
    .FSL_M_Clk(fsl_m_vid_out_clk), 
    .FSL_M_Data(fsl_m_vid_out_data), 
    .FSL_M_Control(fsl_m_vid_out_cntrl), 
    .FSL_M_Write(fsl_m_vid_out_write), 
    .FSL_M_Full(fsl_m_vid_out_full), 
    .FSL_S_Clk(fsl_s_memB_clk), 
    .FSL_S_Data(fsl_s_memB_data), 
    .FSL_S_Control(fsl_s_memB_cntrl), 
    .FSL_S_Read(fsl_s_memB_read), 
    .FSL_S_Exists(fsl_s_memB_exists), 
    .FSL_Full(fsl_2_full), 
    .FSL_Has_Data(fsl_2_has_data)
    );


//Note: currently connected to another memory bank as output
fsl_v20_532 #(.C_FSL_DEPTH(16)) memB_to_vid_out_fsl3 (  
    .FSL_Clk(no_sig), 
    .SYS_Rst(reset), 
    .FSL_Rst(fsl_3_rst), 
    .FSL_M_Clk(fsl_m_memB_clk), 
    .FSL_M_Data(fsl_m_memB_data), 
    .FSL_M_Control(fsl_m_memB_cntrl), 
    .FSL_M_Write(fsl_m_memB_write), 
    .FSL_M_Full(fsl_m_memB_full), 
    .FSL_S_Clk(fsl_s_vid_out_clk), 
    .FSL_S_Data(fsl_s_vid_out_data), 
    .FSL_S_Control(fsl_s_vid_out_cntrl), 
    .FSL_S_Read(fsl_s_vid_out_read), 
    .FSL_S_Exists(fsl_s_vid_out_exists), 
    .FSL_Full(fsl_3_full), 
    .FSL_Has_Data(fsl_3_has_data)
    );
/*
  BUFG RST_BUF(
  .O(rst), 
  .I(int_rst)
  );
*/

//assign led0 = (int_rst == 1'b1) ? 1'b0 : 1'b1;
//assign led0 = (rst == 1'b1) ? 1'b0 : 1'b1;
//assign led1 = (vid_out_rst == 1'b1) ? 1'b0 : 1'b1;

//assign read_not_write = (pres_state == st_write_data) ? 1'b0 : 1'b1;
assign FSL_M_Full_A = 1'b0; //MASTER FSL FROM MEM A IS CURRENTLY UNUSED
//assign FSL_M_Full_B = 1'b0;
//assign FSL_M_Full_C = 1'b0;
//assign fsl_m_vid_in_clk = in_clk;
//assign fsl_m_vid_out_clk = in_clk;
//assign fsl_s_vid_out_clk = in_clk;

//assign CS2b_2 = CS1b_2;
assign CS2b_1 = CS1b_1;
assign CS2b_0 = CS1b_0;
//assign CS2_2 = 1'b1;
assign CS2_1 = 1'b1;
assign CS2_0 = 1'b1;

assign in_clk = core_clk;
assign fsl_rst = fsl_0_rst || fsl_2_rst || fsl_3_rst;
//assign int_rst = reset || fsl_rst;
assign rst = reset || fsl_rst;

always @ (posedge rst or posedge clk_25mhz) begin
  if (rst == 1'b1)
    vid_out_rst <= 1'b1;
  else if(reset_state == total_rst)
    vid_out_rst <= 1'b1;
  else if(reset_state == vid_out_done_rst)
    vid_out_rst <= 1'b0;
  else
    vid_out_rst <= vid_out_rst;
end

always @ (posedge rst or posedge clk_25mhz) begin
  if (rst == 1'b1)
    sh_mem_rst <= 1'b1;
  else if(reset_state == total_rst)
    sh_mem_rst <= 1'b1;
  else if(reset_state == shared_mem_done_rst)
    sh_mem_rst <= 1'b0;
  else
    sh_mem_rst <= sh_mem_rst;
end

always @ (posedge rst or posedge clk_25mhz) begin
  if (rst == 1'b1)
    vid_in_rst <= 1'b1;
  else if(reset_state == total_rst)
    vid_in_rst <= 1'b1;
  else if(reset_state == vid_in_done_rst)
    vid_in_rst <= 1'b0;
  else
    vid_in_rst <= vid_in_rst;
end

always @ (posedge rst or posedge clk_25mhz) begin
  if (rst == 1'b1)
    reset_state <= total_rst;
  else 
    reset_state <= next_reset_state;
end

always @ (reset_state or rst) begin
  case (reset_state)
    total_rst:
      begin
	if (rst==1'b0)
	  next_reset_state <= vid_out_done_rst;
        else
	  next_reset_state <= total_rst;
      end
    vid_out_done_rst:
      begin
	if (rst==1'b1)
	  next_reset_state <= total_rst;
        else
	  next_reset_state <= shared_mem_done_rst;
      end
    shared_mem_done_rst:
      begin
	if (rst==1'b1)
	  next_reset_state <= total_rst;
        else
	  next_reset_state <= vid_in_done_rst;
      end
    vid_in_done_rst:
      begin
	if (rst==1'b1)
	  next_reset_state <= total_rst;
        else
	  next_reset_state <= vid_in_done_rst;
      end
  endcase
end

/*
always @ (posedge core_clk or posedge rst) begin
  if (rst == 1'b1)
    led0 <= 1'b0;
  //else if (fsl_s_memA_exists == 1'b1)
   // led0 <= 1'b0;
  else
    led0 <= 1'b1;
    //led0 <= led0;
end

always @ (posedge core_clk or posedge reset) begin
  if (reset == 1'b1)
    led1 <= 1'b0;
  //else if (fsl_s_memA_cntrl == 1'b1)
    //led1 <= 1'b0;
  else
    //led1 <= led1;
    led1 <= 1'b1;
end
*/
/*
always @ (posedge rst or posedge in_clk) begin
  if (rst == 1'b1)
    vprev_done <= 1'b0;
  else
    vprev_done <= vdone;
end
*/
/*
always @ (posedge rst or posedge core_clk) begin
  if (rst == 1'b1)
    vcontrol_mem <= 1'b0;
  else if (vreq_mem_arb == 1'b1)
    vcontrol_mem <= 1'b1;
  else if ((vdone == 1'b1) && (vprev_done == 1'b0))
    vcontrol_mem <= 1'b0;
  else
    vcontrol_mem <= vcontrol_mem;
end
*/
/*
always @ (posedge in_clk or posedge rst) begin
  if (rst == 1'b1)
     state_cntr <= 3'b000;
  else if ((pres_state == st_write_data_addr) && (next_state == st_start_write_data))
     state_cntr <= state_cntr +1;
  else
     state_cntr <= state_cntr;
end
*/
/*
always @ (posedge rst or posedge in_clk) begin
  if (rst == 1'b1)
     pres_state <= st_write_data_instr;
  else
     pres_state <= next_state;
end
*/
/*
always @ (pres_state or state_cntr or delay_cntr or data_cntr or fsl_m_vid_in_write or rst ) begin
  case (pres_state)
     st_write_data_instr:
        begin
           if ((rst == 1'b0) && (fsl_m_vid_in_write == 1'b1))
              next_state = st_write_data_addr;
           else
	      next_state = st_write_data_instr;
        end
     st_write_data_addr:
        begin
           if (fsl_m_vid_in_write == 1'b1)
              next_state = st_start_write_data;
           else
	      next_state = st_write_data_addr;
        end
     st_start_write_data:
        begin
           if (fsl_m_vid_in_write == 1'b1)
              next_state = st_write_data;
           else
	      next_state = st_start_write_data;
        end
     st_write_data:
        begin
           if ((data_cntr[3:0] == 4'hf) && (state_cntr != 3'b000)
		   && (fsl_m_vid_in_write == 1'b1))
	      next_state = st_write_data_instr;
           else if ((data_cntr[3:0] == 4'hf) && (state_cntr == 3'b000)
		   && (fsl_m_vid_in_write == 1'b1))
              next_state = st_delay;
           else
	      next_state = st_write_data;
        end
     st_delay:
        begin
           if (delay_cntr == 8'hFF)
              next_state = st_write_data_instr;
           else
	      next_state = st_delay;
        end
  endcase
end
*/
/*
always @ (posedge in_clk or posedge rst) begin
  if (rst == 1'b1)
     addr_msb <= 2'b10;
  else if (delay_cntr == 8'hFE)
     addr_msb <= ~addr_msb;
  else
     addr_msb <= addr_msb;
end
*/
/*
always @ (pres_state or data_cntr or state_cntr or fsl_m_vid_in_full) begin
  case (pres_state)
    st_write_data_instr:
       begin
          fsl_m_vid_in_data = `wr_dat_instr;
	  fsl_m_vid_in_cntrl = 1'b1;
	  if (fsl_m_vid_in_full == 1'b0)
	    fsl_m_vid_in_write = 1'b1;
          else
	    fsl_m_vid_in_write = 1'b0;
	  //FSL_S_Exists_A = 1'b1;
       end
    st_write_data_addr:
       begin
       	 case (state_cntr)
	    3'b000:
               fsl_m_vid_in_data = {addr_msb,`wr_dat_0_addr};
	    3'b001:
               fsl_m_vid_in_data = {addr_msb,`wr_dat_20_addr};
	    3'b010:
               fsl_m_vid_in_data = {addr_msb,`wr_dat_40_addr};
	    3'b011:
               fsl_m_vid_in_data = {addr_msb,`wr_dat_60_addr};
	    3'b100:
               fsl_m_vid_in_data = {addr_msb,`wr_dat_10_addr};
	    3'b101:
               fsl_m_vid_in_data = {addr_msb,`wr_dat_30_addr};
	    3'b110:
               fsl_m_vid_in_data = {addr_msb,`wr_dat_50_addr};
	    3'b111:
               fsl_m_vid_in_data = {addr_msb,`wr_dat_70_addr};
         endcase
	  fsl_m_vid_in_cntrl = 1'b0;
	  if (fsl_m_vid_in_full == 1'b0)
	    fsl_m_vid_in_write = 1'b1;
          else
	    fsl_m_vid_in_write = 1'b0;
	  //FSL_S_Exists_A = 1'b1;
       end
    st_start_write_data:
       begin
          fsl_m_vid_in_data = data_cntr;
	  fsl_m_vid_in_cntrl = 1'b0;
	  if (fsl_m_vid_in_full == 1'b0)
	    fsl_m_vid_in_write = 1'b1;
          else
	    fsl_m_vid_in_write = 1'b0;
	  //FSL_S_Exists_A = 1'b1;
       end
    st_write_data:
       begin
          fsl_m_vid_in_data = data_cntr;
	  fsl_m_vid_in_cntrl = 1'b0;
	  if (fsl_m_vid_in_full == 1'b0)
	    fsl_m_vid_in_write = 1'b1;
          else
	    fsl_m_vid_in_write = 1'b0;
	  //FSL_S_Exists_A = 1'b1;
       end
    st_delay:
       begin
          fsl_m_vid_in_data = 32'hFFFFFFFF;
	  fsl_m_vid_in_cntrl = 1'b0;
	  fsl_m_vid_in_write = 1'b0;
	  //FSL_S_Exists_A = 1'b0;
       end
  endcase
end
*/
/*
always @ (posedge rst or posedge in_clk) begin
  if (rst == 1'b1) 
     delay_cntr <= 8'h00;
  //else if ((pres_state == st_write_data_instr) && (fsl_s_memB_read))
  else if (fsl_s_memB_read)
     delay_cntr <= 8'h00;
  else if (pres_state == st_delay)
     delay_cntr <= delay_cntr + 1;
  else
     delay_cntr <= delay_cntr;
end
*/
/*
always @ (posedge rst or posedge in_clk) begin
  if (rst == 1'b1)
     begin
	fsl_m_vid_out_data <= 32'hAAAAAAAA;
	fsl_m_vid_out_cntrl <= 1'b0;
	fsl_m_vid_out_write <= 1'b0;
	//FSL_S_Exists_B <= 1'b0;
     end
  else if (delay_cntr == 8'hFF)
     begin
	fsl_m_vid_out_data <= `noop;
	fsl_m_vid_out_cntrl <= 1'b1;
	if (fsl_m_vid_out_full == 1'b0)
	  fsl_m_vid_out_write <= 1'b1;
        else
	  fsl_m_vid_out_write <= 1'b0;
	//FSL_S_Exists_B <= 1'b1;
     end
  else 
     begin
	fsl_m_vid_out_data <= 32'hAAAAAAAA;
	fsl_m_vid_out_cntrl <= 1'b0;
	fsl_m_vid_out_write <= 1'b0;
	//FSL_S_Exists_B <= 1'b0;
     end
end
*/
/*
always @ (posedge rst or posedge in_clk) begin
  //if ((rst == 1'b1) || (pres_state == st_delay))
  if (rst == 1'b1) 
     data_cntr <= 32'h00000000;
  else if (((pres_state == st_write_data) || 
	  (pres_state == st_start_write_data)) && (fsl_m_vid_in_write == 1'b1))
     data_cntr <= data_cntr + 1;
end
*/
endmodule
