//************************************************************************
//    This file was written for University of Toronto, ECE532 
//    File: fsl_video_output_program.v
//    Used by: fsl_BM_MODE_SVGA_CTRL_532.v
//    Works with ProjectNavigator 6.2.03i
//    Description: Provides the instructions to be executed by the video
//    controller.  It should only be necessary for a user to change the 
//    program to suit the application- the controller should remain
//    unchanged
//
//
//    LLS November 2004
//************************************************************************ 
//
 

module fsl_mem_ctlrB_program (
  // inputs
  clk, rst, 
  
  //Program Interface:
  prog_instr,
  program_cbit,
  prog_instr_read,
  valid_instr,  //only when high should the instruction be read (use to stall)
  sbitA_using_mem0,  //status bit 0: mem0 used by controller 0
  sbitA_using_mem1,  //status bit 1: mem1 used by controller 0
  sbitB_using_mem0,  //status bit 2: mem0 used by controller 1
  sbitB_using_mem1  //status bit 3: mem1 used by controller 1
  );

  input clk, rst;
  output [0:31] prog_instr;  //Next instruction to be executed by the controller
  output program_cbit;
  output valid_instr;
  input prog_instr_read; //Read the instruction on the prog_instr bus
  input sbitA_using_mem0; //Status_bit 0
  input sbitA_using_mem1; //Status_bit 1
  input sbitB_using_mem0; //Status_bit 2
  input sbitB_using_mem1; //Status_bit 3
	  
  wire clk, rst;

  //Program interface:
  wire [0:31] prog_instr;
  wire program_cbit;
  wire prog_instr_read; 
  wire valid_instr; 


assign prog_instr = 32'h00000000;
assign program_cbit = 1'b0;
assign valid_instr = 1'b0;

endmodule
