//************************************************************************
//    This file was written for University of Toronto, ECE532 
//    File: fsl_video_program.v
//    Used by: fsl_video_input.v
//    Works with ProjectNavigator 6.2.03i
//    Description: Provides the instructions to be executed by the video
//    controller.  It should only be necessary for a user to change the 
//    program to suit the application- the controller should remain
//    unchanged
//
//
//    LLS October 2004
//************************************************************************ 
//
 

module fsl_video_program (
  // inputs
  clk, rst, 
  
  //Program Interface:
  prog_instr,
  program_cbit,
  prog_instr_read,
  valid_instr,  //only when high should the instruction be read (use to stall)
  done_field, //Status_bit 0
  done_frame, //Status_bit 1
  video_in_on, //Status_bit 2
  Hmid  //Status bit 3- indicates new line coming- 4 clock cycles early to 
  		//allow for processing
  );

  input clk, rst;
  output [0:31] prog_instr;  //Next instruction to be executed by the controller

  output program_cbit;
  output valid_instr;
  input prog_instr_read; //Read the instruction on the prog_instr bus
  input done_field; //Status_bit 0
  input done_frame; //Status_bit 1
  input video_in_on; //Status_bit 2
  input Hmid; //Status bit 3
	  
  wire clk, rst;
 
  //Program interface:
  wire [0:31] prog_instr;
  wire program_cbit;
  wire valid_instr;

 assign prog_instr = 32'h00000000;
 assign program_cbit = 1'b0;
 assign valid_instr = 1'b0;
endmodule
